clearlog()

print("Script for switching traffic lights on multiple crossings")
print("       by EepNolie - visit at http://www.eep.nolie.be")

cntr_amp=0									-- counter for traffic light switching
---------------------------------------------------------------------------------------------
-- EDIT THIS PART :
crossings=3									-- number of crossings in the layout
tmr_cycle1=100								-- duration of cycle 1
tmr_cycle2=110								-- duration of cycle 2
tmr_cycle3=210								-- duration of cycle 3
tmr_cycle4=220								-- duration of cycle 4
-- a counter of 5 = 1 second
-- values should be added to the previous cycle, e.g. if the first cycle = 20 seconds and then
--   second cycle = 2 seconds then value for the first cycle = 100 and for the second 
--   cylce = 100 + 10 (110)
--   and so on...
---------------------------------------------------------------------------------------------
signals=1									-- pointer name for the table
data_amp={}									-- create table (as much crossings as needed)
for x=1,crossings,1 do 
	data_amp[x]={}
end
---------------------------------------------------------------------------------------------
-- EDIT THIS PART(add lines as many times as you have crossings) :
-- example : data_amp[A][signals]={B,C,D,E}
--     where A    = the number of the crossing (always start with 1 as first)
--           B->E = the signal numbers on the crossing

data_amp[1][signals]={5,7,6,8}            	-- numbers of the signals (paired)
data_amp[2][signals]={9,14,13,999}       	-- use 999 or high value as dummy signals
data_amp[3][signals]={15,16,999,999} 
---------------------------------------------------------------------------------------------
function set_traffic_lights()
-- for each crossing the status of the lights is set : Red, Green or Orange (if present)
-- the timing depends of the counter (5 = 1 second)
--   at start : initial setting (1 (pair) red, 1 (pair) green)
--   first cycle : after 20 seconds (red stays res, green becomes orange)
--   second cycle : after 2 seconds (orange becomes red, red becomes green)
--   third cycle : after 20 seconds (red stay red, green becomes orange)
--   fourth cycle : after 2 seconds go to initial setting and reset counter
--   and so on...
--   if no orange present, this will be ignored

	for x=1,crossings,1 do 
		if cntr_amp==0 then
			EEPSetSignal(data_amp[x][signals][1],1)	-- G
			EEPSetSignal(data_amp[x][signals][2],1)	-- G
			EEPSetSignal(data_amp[x][signals][3],2)	-- R
			EEPSetSignal(data_amp[x][signals][4],2)	-- R
		elseif cntr_amp==tmr_cycle1 then
			EEPSetSignal(data_amp[x][signals][1],3)	-- O
			EEPSetSignal(data_amp[x][signals][2],3)	-- O
			EEPSetSignal(data_amp[x][signals][3],2)	-- R
			EEPSetSignal(data_amp[x][signals][4],2)	-- R
		elseif cntr_amp==tmr_cycle2 then
			EEPSetSignal(data_amp[x][signals][1],2)	-- R
			EEPSetSignal(data_amp[x][signals][2],2)	-- R
			EEPSetSignal(data_amp[x][signals][3],1)	-- G
			EEPSetSignal(data_amp[x][signals][4],1)	-- G
		elseif cntr_amp==tmr_cycle3 then
			EEPSetSignal(data_amp[x][signals][1],2)	-- R
			EEPSetSignal(data_amp[x][signals][2],2)	-- R
			EEPSetSignal(data_amp[x][signals][3],3)	-- O
			EEPSetSignal(data_amp[x][signals][4],3)	-- O
		end
	end
	cntr_amp=cntr_amp+1
	if cntr_amp>tmr_cycle4 then cntr_amp=0 end
end
---------------------------------------------------------------------------------------------
function EEPMain()
	set_traffic_lights()
    return 1
end
---------------------------------------------------------------------------------------------